import java.util.*;

public class Demo1 implements GameEngine
{
	private PhysicsEngine phys;
	
	public Demo1()
	{
		phys = new PhysicsEngine();
		BoundingCircle a = new BoundingCircle(1,50,new Vector2D(200,200));		//creat 2 circles
		BoundingCircle b = new BoundingCircle(5,75,new Vector2D(700,300));
		getEnv().addObject(a);			//add them to environment
		getEnv().addObject(b);
		a.setVelocity(new Vector2D(500,0));		//starting velocities
		b.setVelocity(new Vector2D(-100,0));
	}
	
	public void act()
	{
		phys.act();
	}
	
	public PhysicsEnv getEnv()
	{
		return phys.getEnv();
	}
}