import java.awt.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class TheDemo_Graphics extends KeyboardAnimationApplet2 implements MouseMotionListener {
	
	TheDemonstration game;
	
	boolean bDown, bUp, bLeft, bRight,bSpace;
	private Vector2D mouseLoc = new Vector2D(0,0);

	//----------------------------------------------   
   //###############################################
   //#############Define Game Engine################
   //###############################################
   
      void initEnv(int size) {
       game = new TheDemonstration();
       bDown=bUp=bLeft=bRight=bSpace=false;      
      }
      
  //---------------------------------------------- 
	
	
	   //----------------------------------------------
	   
	   protected void doInitialization(int width, int height) {
         // This routine will be called once, when the animation applet
         // is first created.
         // The parameters width and height
         // give the width and height of the drawing area.
      setMillisecondsPerFrame(25);   
      initEnv(width);
      addMouseMotionListener(this);
      
      
      }
       synchronized public void drawFrame(Graphics g, int width, int height) {

         // This routine is called to draw the next frame of the animation.
          // The parameter, g, is a graphics context for drawing the frame.
          // The parameters width and height give the size of the frame.
          // Here, methods are called to process and draw each of the
          // three objects in the scene.
   
       // First, fill the whole drawing area with green
      
       g.setColor(Color.white);
       g.fillRect(0,0,width,height);
       
       // Now, draw the objects in the scene. These subroutines
       // are defined below.  They also change values of instance
       // variables so that the scene will change from one frame to
       // the next.
       
       handleKeys();
       
       doEnvFrame(g, width, height);
       
   }
   
	/*public void mousePressed(MouseEvent e) 
	{
		
	}*/
	
	public void mouseEvent(MouseEvent e)
	{
		if (e.getButton() == MouseEvent.BUTTON1)
			game.addObject(e.getX(),e.getY());
		if (e.getButton() == MouseEvent.BUTTON3)
			game.rightClick(e.getX(),e.getY());
		
	}
	
	public void mouseMoved(MouseEvent e)
	{
		mouseLoc.setI(e.getX());
		mouseLoc.setJ(e.getY());
	}
	
	public void mouseDragged(MouseEvent e)
	{
		
	}
   
  void doEnvFrame(Graphics g, int width, int height) {
  	
  	game.act();
	PointMass p;
	/*g.setColor(Color.black);
	g.fillRect(0,0,800,800);*/
	ArrayList l = game.getEnv().getAllObjects();
	
	for (int i = 0; i < l.size(); i++)
	{
		//System.out.println("Iterating list of objects to draw...");
		p = (PointMass)l.get(i);
		/*if (o == 10)
			o = 0;
		g.setColor(colors[o]);
		
		o++;*/
		if (p != null)
		{
			if (p.CLASS() == 1)
				paintCircle((BoundingCircle)p, game.getEnv().getLoc(p),g);
			if (p.CLASS() == 2)
				paintAABB((AABB)p,game.getEnv().getLoc(p),g);
		}
	}
	
	l = game.getEnv().getAllConstraints();
	Constraint c;
	for (int i = 0; i < l.size(); i++)
	{
		//System.out.println("Iterating list of constraints to draw...");
		c = (Constraint)l.get(i);
		
		if (c != null)
		{
			paintConstraint(c, game.getEnv().getLoc(c),g);
		}
	}
	
	l = game.getEnv().getAllDoubleConstraints();
	DoubleConstraint c2;
	for (int i = 0; i < l.size(); i++)
	{
		//System.out.println("Iterating list of constraints to draw...");
		c2 = (DoubleConstraint)l.get(i);
		
		if (c2 != null)
		{
			paintDoubleConstraint(c2,g);
		}
	}
	
	Vector2D anchor = game.getAnchor();
	if (anchor != null && mouseLoc != null)
	{
		g.drawLine((int)anchor.getI(),(int)anchor.getJ(),(int)mouseLoc.getI(),(int)mouseLoc.getJ());
	}
	
	String str;
	g.setColor(Color.yellow);
	g.drawString("Constraint Type: " + game.getConstraintType(),50,735);
	str = "Objects: " + (game.getEnv().getAllObjects().size()-4);
	g.drawString(str,50,750);
	if (game.buildMode)
		str = "BUILD MODE";
	else
		str = "PLAY MODE";
	g.drawString(str,50,720);
	if (game.bStatic)
		str = "Static Mode: ON";
	else
		str = "Static Mode: off";
	g.drawString(str,50,765);
	if (game.bBoxes())
		str = "Boxes Toggled";
	else
		str = "Circles Toggled";
	g.drawString(str,50,780);
	
	g.drawString("Controls:",575,715);
	//g.drawString("Move Box: ARROW KEYS",600,730);
	g.drawString("Toggle Boxes/Circles: ENTER",575,730);
	g.drawString("Add Object: LEFT CLICK",575,745);
	g.drawString("Static Mode: SPACEBAR",575,760);
	g.drawString("Constraint Type: C",575,775);
	g.drawString("K-Value = " + game.getK(),430,715);
	g.drawString("Adjust K-Value: A/S",430,730);
	g.drawString("Toggle Build/Play: B",430,745);
	g.drawString("Add Constraint: RIGHT CLICK",360,760);
	g.drawString("Delete Object: BACKSPACE",370,775);
	//g.drawString("Rattle Blocks: RIGHT CLICK",600,745);
  }
   
   private void handleKeys()
   {/*
   	if (bLeft)
   		game.hitBox(new Vector2D(-1,0));
   	if (bRight)
   		game.hitBox(new Vector2D(1,0));
   	if (bUp)
   		game.hitBox(new Vector2D(0,-1));
   	if (bDown)
   		game.hitBox(new Vector2D(0,1));*/
   	
   }
      //----------------------------------------------
      
       
      
     synchronized public void keyPressed(KeyEvent evt) {
          // This routine is called each time the user presses
          // a key on the keyboard (while the applet has the keyboard
          // focus).  The value of evt.getKeyCode() tells which
          // key was pressed.  For this applet, only the three of the
          // arrow keys will have any effect.  The codes for the
          // four arrow keys are KeyEvent.VK_UP, KeyEvent.VK_DOWN,
          // KeyEvent.VK_LEFT, and KeyEvent.VK_RIGHT.

       int code = evt.getKeyCode();  // which key was pressed
       if (code == KeyEvent.VK_SPACE)
       {
       		game.changeStaticMode();
       }
       if (code == KeyEvent.VK_ENTER)
       {
       		game.toggleBoxes();
       }
       if (code == KeyEvent.VK_C)
       {
       		game.changeConstraint();
       }
       if (code == KeyEvent.VK_BACK_SPACE)
       {
       		game.removeObject((int)mouseLoc.getI(),(int)mouseLoc.getJ());
       }
       if (code == KeyEvent.VK_B)
       {
       		game.toggleBuildMode();
       }
       if (code == KeyEvent.VK_A)
       {
       		game.addK(-1);
       }
       if (code == KeyEvent.VK_S)
       {
       		game.addK(1);
       }
       
       if (code == KeyEvent.VK_LEFT) 
   		bLeft = true;
       	
       else if (code == KeyEvent.VK_RIGHT)
		bRight = true;

       else if (code == KeyEvent.VK_DOWN) 
		bDown = true;

       else if (code == KeyEvent.VK_UP)
         bUp = true;

       /*else if (code == KeyEvent.VK_SPACE) {
       		if (getElapsedTime() - bombTimer > BOMB_COOL)
       		{
	       		score += env.getPlayer().bomb(BLAST);
	       		iBomb = PLAYER_RAD;
	       		bombTimer = getElapsedTime();
	       	}
	   }
       
       else if (code == KeyEvent.VK_N) {
       		if (getElapsedTime() - nukeTimer > NUKE_COOL)
       		{
	       		score += env.getPlayer().bomb(env.SIZE);
	       		iNuke = NUKE_FADE;
	       		nukeTimer = getElapsedTime();
	       	}
       	}
       
   //System.out.println("Player moved.");*/
   
   } // end keyPressed()
   
   synchronized public void keyReleased(KeyEvent evt) {
   		int code = evt.getKeyCode();
   		if (code == KeyEvent.VK_LEFT) 
       		bLeft = false;
       	
       else if (code == KeyEvent.VK_RIGHT)
			bRight = false;

       else if (code == KeyEvent.VK_DOWN)
			bDown = false;  

       else if (code == KeyEvent.VK_UP)
         bUp = false;
   	}

	public void paintCircle(BoundingCircle c, Vector2D loc, Graphics g)
	{
		//System.out.println("Printing point " + p + " at vector location " + loc);
		int x = (int)loc.getI(), y = (int)loc.getJ();
		int r = (int)(c.getRadius());
		//System.out.println("Drawing circle at " + x + ", " + y);
		
		g.setColor(Color.black);
		if (c.bStationary())
		{
			g.fillOval(x-r,y-r,r*2,r*2);
		} else if (c.bSleeping())
		{
			//g.setColor(Color.gray);
			//g.fillOval(x-r,y-r,r*2,r*2);
			g.setColor(Color.black);
			g.drawOval(x-r,y-r,r*2,r*2);
		} else
			g.drawOval(x-r,y-r,r*2,r*2);
		/*g.setColor(Color.green);
		//g.drawLine(x,y,x+(int)c.getAcceleration().getI()/500,y+(int)c.getAcceleration().getJ()/500);
		Vector2D n = new Vector2D(c.getVelocity().getJ(),-c.getVelocity().getI());
		g.drawLine(x,y,x+(int)n.getI(),y+(int)n.getJ());
		g.setColor(Color.red);
		g.drawLine(x,y,x+(int)c.getVelocity().getI(),y+(int)c.getVelocity().getJ());*/
	}
	
	public void paintPoint(PointMass p, Vector2D loc, Graphics g)
	{
		//System.out.println("Printing point " + p + " at vector location " + loc);
		int x = (int)loc.getI(), y = (int)loc.getJ();
		g.setColor(Color.black);
		//System.out.println("Drawing circle at " + x + ", " + y);
		g.fillOval(x-10,y-10,20,20);
	}
	
	public void paintConstraint(Constraint c, Vector2D loc, Graphics g)
	{
		int x = (int)loc.getI(), y = (int)loc.getJ(),
			x2 = (int)game.getEnv().getLoc(c.getObject()).getI(), 
			y2 = (int)game.getEnv().getLoc(c.getObject()).getJ();
		g.setColor(Color.black);
		
		g.drawLine(x,y,x2,y2);
	}
	
	public void paintDoubleConstraint(DoubleConstraint c, Graphics g)
	{
		int x = (int)game.getEnv().getLoc(c.getObjA()).getI(), 
			y = (int)game.getEnv().getLoc(c.getObjA()).getJ(),
			x2 = (int)game.getEnv().getLoc(c.getObjB()).getI(), 
			y2 = (int)game.getEnv().getLoc(c.getObjB()).getJ();
		g.setColor(Color.black);
		
		g.drawLine(x,y,x2,y2);
	}
	
	public void paintAABB(AABB p, Vector2D loc, Graphics g)
	{
		int x = (int)loc.getI(), y = (int)loc.getJ(), w = p.getWidth(), h = p.getHeight();
		
		g.setColor(Color.black);
		if (p.bStatic())
		{
			if (p.bSleeping())
			{
				g.setColor(Color.gray);
				g.fillRect(x-w,y-h,w*2,h*2);
				g.setColor(Color.black);
				g.drawRect(x-w,y-h,w*2,h*2);
			}
			else
				g.fillRect(x-w,y-h,w*2,h*2);
		}
		else
			g.drawRect(x-w,y-h,w*2,h*2);
		/*g.drawLine(x-w,y+h,x+w,y+h);
		g.drawLine(x-w,y-h,x+w,y-h);
		g.drawLine(x+w,y+h,x+w,y-h);
		g.drawLine(x-w,y-h,x-w,y+h);*/
		
		/*g.setColor(Color.green);
		g.drawLine(x,y,x+(int)p.getAcceleration().getI()/500,y+(int)p.getAcceleration().getJ()/500);
		g.setColor(Color.red);
		g.drawLine(x,y,x+(int)p.getVelocity().getI()/100,y+(int)p.getVelocity().getJ()/100);*/
	}
	
}

/*
   This is a simple arcard game in which the user tries to blow up
   a submarine (a black oval) by dropping depth charges from a
   ship (a blue roundrect).  The user moves the boat with the
   left- and right-arrow keys and drops the depth charge with the
   down-arrow key.
 
   The sub killer applet is based on KeyboardAnimationApplet2, which is
   a framework for applets that display animated action while allowing
   keyboard input from the user to affect the action.  See the file
   KeyboardAnimationApplet2.java for more information.
   
   (Note that the KeyboardAnimationApplet2 class already implements
   KeyListener, FocusListener, and MouseListener.)


import java.awt.*;        // for access to GUI classes
import java.awt.event.*;  // for access to the KeyEvent class


public class SubKillerGame extends KeyboardAnimationApplet2 {



   // -------------- Instance variables and method for the bomb -------------
   
   int bombCenterX;  // Horizontal coordinate of the center of the bomb.
   int bombCenterY;  // Vertical coordinate of the center of the bomb.

   boolean bombIsFalling;  // This is set to true when the boat releases the
                           //    bomb.  While it is false, the bomb is 
                           //    attached to the boat.  While it is true,
                           //    the vertical coordinate of the bomb increases
                           //    in each frame, so the bomb falls.

   void initBomb(int width, int height) {
          // Initialize instance variables that pertain to the bomb.
       bombIsFalling = false;
       bombCenterY = 100;
   }
   
   void doBombFrame(Graphics g, int width, int height) {
          // If the bomb is NOT falling, just draw it under the center of the boat.
          // If it is falling, move it downwards and then check whether
          // it has either hit the sub or fallen off the applet.  In either
          // case, its state changes to not falling (and so it reappears
          // back under the boat in the next frame).
       if (bombIsFalling) {
          if (bombCenterY > height) {
                // Bomb has missed the submarine.  It is returned to its intial state.
                // It's not drawn in this frame, but it will appear in the next.
             initBomb(width, height);
             bombCenterX = boatCenterX;
          }
          else if (Math.abs(bombCenterX - subCenterX) <= 36 &&
                      Math.abs(bombCenterY - subCenterY) <= 21) {
                // Bomb has hit the submarine.  It is not
                // drawn in this frame, but an explosion starts,
                // and the bomb is returned to its initial state.
             explosionFrameNumber = 1;
             initBomb(width, height);
             bombCenterX = boatCenterX;
          }
          else {
             bombCenterY += 10;
             g.setColor(Color.red);
             g.fillOval(bombCenterX - 8, bombCenterY - 8, 16, 16);
          }
       }
       else {
             // Bomb is not falling.  It is attached to the boat.
             // Use the boat's horizontal position for the bomb.
          bombCenterX = boatCenterX;
          g.setColor(Color.red);
          g.fillOval(bombCenterX - 8, bombCenterY - 8, 16, 16);
       }
   }



   // -------------- Instance variables and method for the boat -------------
   
   int boatCenterX;  // Horizontal coordinate of the center of the boat.
   int boatCenterY;  // Vertical coordinate of the center of the boat.

   void initBoat(int width, int height) {
          // Initialize instance variables that pertain to the boat.
      boatCenterX = width/2;
      boatCenterY = 80;
   }

   void doBoatFrame(Graphics g, int width, int height) {
          // Draw the boat.  Make sure that the boat's horizontal
          // position is within the range 0 to width.  This prevents
          // the user from moving the boat off the screen.
      if (boatCenterX < 0)
         boatCenterX = 0;
      else if (boatCenterX > width)
         boatCenterX = width;
      g.setColor(Color.blue);
      g.fillRoundRect(boatCenterX - 40, boatCenterY - 20, 80, 40, 20, 20);
   }


   // -------------- Instance variables and method for the submarine -------------
   
   int subCenterX;  // Horizontal coordinate of the center of the submarine.
   int subCenterY;  // Vertical coordinate of the center of the submarine.
   
   boolean subIsMovingLeft;  // Sub can be moving left or right; this variable tells which.
   
   int explosionFrameNumber; // While the sub is exploding, this tells for how many
                             //    frames the explosiong has been in progress.  When the
                             //    sub is not explosing, the value of this variable is 0.
                             //    when the bomb hits the sub, the value is set to 1 in
                             //    the doBombFrame method.  When explosiongFrameNumber
                             //    reaches 14, the explosion ends and a new sub is
                             //    created.
  
   void initSubmarine(int width, int height) {
          // Initialize the instance variables that pertain to the submarine.
          // The sub is placed in a random horizontal position, 40 pixels from
          // the bottom of the drawing area.  Its direction of motion is
          // set randomly to either left or right.  At the beginning, the
          // sub is not exploding.
      subCenterX = (int)(width * Math.random());
      subCenterY = height - 40;
      explosionFrameNumber = 0;
      if (Math.random() < 0.5)
         subIsMovingLeft = true;
      else
         subIsMovingLeft = false;
   }
   
   void doSubmarineFrame(Graphics g, int width, int height) {
         // Draw the submarine and update the instance variables that
         // describe it.  The sub has two very different states,
         // depending on whether or not it is exploding.  Note that
         // at the end of an explosion, the bomb is reinitialized so
         // that it appears again under the boat.

      if (explosionFrameNumber > 0) {

         if (explosionFrameNumber == 14) {  // In the 14-th frame...
            initSubmarine(width,height);    //    ... create a new sub (also sets explosionFrameNumber to 0)
         }
            
         else if (explosionFrameNumber > 10) { // For frames 11, 12, and 13,
                                               //   there is no sub
             explosionFrameNumber++;  // Just go to next frame of explosion sequence
         }
         
         else {  // For frames 1 through 10, draw the sub under an expanding explosion
            g.setColor(Color.black);
            g.fillOval(subCenterX - 30, subCenterY - 15, 60, 30);
            g.setColor(Color.yellow);
            g.fillOval(subCenterX - 4*explosionFrameNumber,
                       subCenterY - 2*explosionFrameNumber,
                       8*explosionFrameNumber,
                       4*explosionFrameNumber);
            g.setColor(Color.red);
            g.fillOval(subCenterX - 2*explosionFrameNumber,
                       subCenterY - explosionFrameNumber/2,
                       4*explosionFrameNumber,
                       explosionFrameNumber);
            explosionFrameNumber++;  // Go on to next frame of explosion.
         }
            
      }
            
      else { // Sub is not exploding.  Move the sub and draw it in its new position
      
         if (Math.random() < 0.04)               // One time out of 25, on average...
            subIsMovingLeft = !subIsMovingLeft;  //   ...randomly reverse direction
            
         if (subIsMovingLeft) { 
            subCenterX -= 5;        // Move the sub left 5 pixels.
            if (subCenterX <= 0) {  // If sub has moved off left hand edge of applet...
               subCenterX = 0;      //       ...move it back to the left edge...
               subIsMovingLeft = false; //  ...and start it moving right.
            }
         }
         else {
            subCenterX += 5;           // Move the sub right 5 pixels.
            if (subCenterX > width) {  // If the sub has moved off the right edge...
               subCenterX = width;     //    ...move it back to the right edge...
               subIsMovingLeft = true; //    ...and start it moving left.
            }
         }
         g.setColor(Color.black);  // Draw the sub
         g.fillOval(subCenterX - 30, subCenterY - 15, 60, 30);
      }

   }  // end doSubmarineFrame 
   
   

} // end class SubKiller


   protected void doInitialization(int width, int height) {
         // This routine will be called once, when the animation applet
         // is first created.  The three objects that appear in the
         // applet are initialized, by calling methods that are defined
         // later in this class.  The parameters width and height
         // give the width and height of the drawing area.
         
      initSubmarine(width, height);  
      initBoat(width, height); 
      initBomb(width,height);
      
   } // end doInitialization()


   synchronized public void drawFrame(Graphics g, int width, int height) {
          // This routine is called to draw the next frame of the animation.
          // The parameter, g, is a graphics context for drawing the frame.
          // The parameters width and height give the size of the frame.
          // Here, methods are called to process and draw each of the
          // three objects in the scene.
   
       // First, fill the whole drawing area with green
       
       g.setColor(Color.green);
       g.fillRect(0,0,width,height);
       
       // Now, draw the objects in the scene. These subroutines
       // are defined below.  They also change values of instance
       // variables so that the scene will change from one frame to
       // the next.
       
       doBoatFrame(g, width, height);
       doSubmarineFrame(g, width, height);
       doBombFrame(g, width, height);
       
   } // end drawFrame()
   
   
   synchronized public void keyPressed(KeyEvent evt) {
          // This routine is called each time the user presses
          // a key on the keyboard (while the applet has the keyboard
          // focus).  The value of evt.getKeyCode() tells which
          // key was pressed.  For this applet, only the three of the
          // arrow keys will have any effect.  The codes for the
          // four arrow keys are KeyEvent.VK_UP, KeyEvent.VK_DOWN,
          // KeyEvent.VK_LEFT, and KeyEvent.VK_RIGHT.

       int code = evt.getKeyCode();  // which key was pressed

       if (code == KeyEvent.VK_LEFT) {
               // Move the boat left.  (If this moves the boat out of the 
               // frame, its position will be adjusted in the doBoatFrame() method.)
          Location temp = new Location();
          
          boatCenterX -= 15;
       }
       else if (code == KeyEvent.VK_RIGHT) {  
               // Move the boat right.  (If this moves the boat out of the 
               // frame, its position will be adjusted in the doBoatFrame() method.)
          boatCenterX += 15;
       }
       else if (code == KeyEvent.VK_DOWN) {
               // Start the bomb falling, it is is not already falling.
               // (The test is not really necessary, since if bombIsFalling
               // is already true, the assignment bombIsFalling = true has
               // no effect anyway.)
          if ( bombIsFalling == false )
             bombIsFalling = true;
       }
   
   } // end keyPressed()
   
*/